diff -u -Naur emacs-21.2/confdefs.h emacs-f/confdefs.h
--- emacs-21.2/confdefs.h	Wed Dec 31 19:00:00 1969
+++ emacs-f/confdefs.h	Thu Oct 10 11:01:22 2002
@@ -0,0 +1,2 @@
+
+#define MAIL_USE_POP 1
diff -u -Naur emacs-21.2/configure.in emacs-f/configure.in
--- emacs-21.2/configure.in	Fri Mar 15 07:44:20 2002
+++ emacs-f/configure.in	Thu Oct 10 11:01:23 2002
@@ -28,8 +28,9 @@
 AC_CONFIG_HEADER(src/config.h:src/config.in)
 
 lispdir='${datadir}/emacs/${version}/lisp'
-locallisppath='${datadir}/emacs/${version}/site-lisp:'\
-'${datadir}/emacs/site-lisp:${datadir}/emacs/${version}/leim'
+
+locallisppath='@PREFIX@/etc/emacs21:@PREFIX@/etc/emacs:@PREFIX@/etc/lisp/emacs/21.2/site-lisp:'\
+'@PREFIX@/etc/lisp/emacs/site-lisp:${datadir}/emacs/${version}/site-lisp:${datadir}/emacs/site-lisp:${datadir}/emacs/${version}/leim'
 lisppath='${locallisppath}:${lispdir}'
 etcdir='${datadir}/emacs/${version}/etc'
 archlibdir='${libexecdir}/emacs/${version}/${configuration}'
@@ -546,6 +547,24 @@
   ;;
   hppa*-*-nextstep* )
     machine=hp800 opsys=nextstep
+  ;;
+
+  ## Mac OS X Server
+  *-*-rhapsody*)
+    opsys=rhapsody
+    case "${canonical}" in
+      powerpc-*-rhapsody*) machine=powermacintosh ;;
+      i386-*-rhapsody*)    machine=intel386 ;;
+    esac
+  ;;
+
+  ## Darwin / Mac OS X
+  *-*-darwin*)
+    opsys=darwin
+    case "${canonical}" in
+      powerpc-*-darwin*) machine=powermacintosh ;;
+      i?86-*-darwin*)    machine=intel386 ;;
+    esac
   ;;
 
   ## Orion machines
diff -u -Naur emacs-21.2/fix-info emacs-f/fix-info
--- emacs-21.2/fix-info	Wed Dec 31 19:00:00 1969
+++ emacs-f/fix-info	Thu Oct 10 11:01:23 2002
@@ -0,0 +1,10 @@
+#!/bin/sh
+
+THE_INFO_PREFIX=$1
+
+for file in ada-mode autotype ccmode cl dired-x ebrowse ediff efaq \
+            emacs emacs-mime eshell eudc forms gnus idlwave info message mh-e \
+            pcl-cvs reftex sc speedbar vip viper widget woman
+do
+    ./mangle-info ${THE_INFO_PREFIX}/${file}
+done
diff -u -Naur emacs-21.2/lisp/startup.el emacs-f/lisp/startup.el
--- emacs-21.2/lisp/startup.el	Thu Nov  1 08:10:34 2001
+++ emacs-f/lisp/startup.el	Thu Oct 10 11:01:23 2002
@@ -339,6 +339,10 @@
 
 (defvar normal-top-level-add-subdirs-inode-list nil)
 
+(defconst fink-emacs-flavor 'emacs21
+  "A symbol representing the particular fink flavor of emacs running.
+Something like 'emacs20, 'xemacs20, etc.")
+
 (defun normal-top-level-add-subdirs-to-load-path ()
   "Add all subdirectories of current directory to `load-path'.
 More precisely, this uses only the subdirectories whose names
@@ -848,8 +852,20 @@
     ;; Run the site-start library if it exists.  The point of this file is
     ;; that it is run before .emacs.  There is no point in doing this after
     ;; .emacs; that is useless.
-    (if site-run-file 
-	(load site-run-file t t))
+
+    ;; (if site-run-file                                                       
+    ;;     (load site-run-file t t))                                           
+                                                                               
+    ;; Fink version of site-start.                                           
+    (if site-run-file                                                          
+        (progn                                                                 
+          ;; Load all the fink package snippets.                             
+          ;; It's in here because we want -q to kill it too.                   
+          (if (load "fink-startup" t t nil)                                  
+              (fink-startup fink-emacs-flavor))                            
+          ;; Now the normal site file...                                       
+          (load site-run-file t t nil)))                                       
+
 
     ;; Sites should not disable this.  Only individuals should disable
     ;; the startup message.
diff -u -Naur emacs-21.2/mangle-info emacs-f/mangle-info
--- emacs-21.2/mangle-info	Wed Dec 31 19:00:00 1969
+++ emacs-f/mangle-info	Thu Oct 10 11:01:23 2002
@@ -0,0 +1,17 @@
+#!/usr/bin/perl -w -i
+
+use English;
+use strict;
+
+$RS = undef;
+
+my $prefix = "emacs-21";
+
+my $x = <>;
+if(!($x =~ m/^(\s*START-INFO-DIR-ENTRY\s+\*\s*[^:]+:\s*)\(([^\)]+)\)/mo)) {
+  die "Couldn't find START-INFO-DIR-ENTRY.";
+}
+   
+print ${PREMATCH};
+print "$1($prefix/$2)";
+print ${POSTMATCH};
diff -u -Naur emacs-21.2/src/callproc.c emacs-f/src/callproc.c
--- emacs-21.2/src/callproc.c	Sun Nov 25 19:37:40 2001
+++ emacs-f/src/callproc.c	Thu Oct 10 11:01:23 2002
@@ -611,7 +611,11 @@
     pid = child_setup (filefd, fd1, fd_error, (char **) new_argv,
 		       0, current_dir);
 #else  /* not WINDOWSNT */
+#ifndef PUMA_VFORK_ISSUES_CLEARED_UP
+    pid = fork ();
+#else
     pid = vfork ();
+#endif
 
     if (pid == 0)
       {
diff -u -Naur emacs-21.2/src/emacs.c emacs-f/src/emacs.c
--- emacs-21.2/src/emacs.c	Mon Oct 29 06:31:07 2001
+++ emacs-f/src/emacs.c	Thu Oct 10 11:01:16 2002
@@ -779,15 +779,20 @@
     }
 #endif
 
-#ifdef NeXT
+#if defined(NeXT) || defined(RHAPSODY) || defined(DARWIN)
   {
     extern int malloc_cookie;
-    /* This helps out unexnext.c.  */
+    /* This helps out unexnext.c/unexdyld.c. */
     if (initialized)
-      if (malloc_jumpstart (malloc_cookie) != 0)
-	printf ("malloc jumpstart failed!\n");
+      {
+	if (malloc_jumpstart (malloc_cookie) != 0)
+	  {
+	    fprintf (stderr, "Fatal malloc_jumpstart() error\n");
+	    exit (1);
+	  }
+      }
   }
-#endif /* NeXT */
+#endif /* NeXT || RHAPSODY || DARWIN */
 
 #ifdef VMS
   /* If -map specified, map the data file in */
@@ -1466,7 +1471,7 @@
 #ifdef VMS
   init_vmsfns ();
 #endif /* VMS */
-  init_process ();
+  init_emacs_process ();
 #ifdef HAVE_SOUND
   init_sound ();
 #endif
diff -u -Naur emacs-21.2/src/floatfns.c emacs-f/src/floatfns.c
--- emacs-21.2/src/floatfns.c	Fri Feb 22 05:51:46 2002
+++ emacs-f/src/floatfns.c	Thu Oct 10 11:01:23 2002
@@ -978,6 +978,9 @@
 #endif /* FLOAT_CATCH_SIGILL */
 
 #ifdef HAVE_MATHERR
+#ifdef __APPLE_CC__
+__private_extern__
+#endif
 int 
 matherr (x)
      struct exception *x;
diff -u -Naur emacs-21.2/src/getloadavg.c emacs-f/src/getloadavg.c
--- emacs-21.2/src/getloadavg.c	Tue Jun 20 09:17:40 2000
+++ emacs-f/src/getloadavg.c	Thu Oct 10 11:01:23 2002
@@ -54,6 +54,8 @@
    hpux
    __MSDOS__			No-op for MSDOS.
    NeXT
+   RHAPSODY			Mac OS X Server
+   DARWIN			Darwin (Mac OS)
    sgi
    sequent			Sequent Dynix 3.x.x (BSD)
    _SEQUENT_			Sequent DYNIX/ptx 1.x.x (SYSV)
@@ -401,7 +403,7 @@
 #  define host_self mach_host_self
 # endif
 
-# ifdef NeXT
+# if defined(NeXT) || defined(RHAPSODY) || defined(DARWIN)
 #  ifdef HAVE_MACH_MACH_H
 #   include <mach/mach.h>
 #  else
@@ -449,7 +451,7 @@
 
 /* Avoid static vars inside a function since in HPUX they dump as pure.  */
 
-# ifdef NeXT
+# if defined(NeXT) || defined(RHAPSODY) || defined(DARWIN)
 static processor_set_t default_set;
 static int getloadavg_initialized;
 # endif /* NeXT */
@@ -486,6 +488,9 @@
    Return the number written (never more than 3, but may be less than NELEM),
    or -1 if an error occurred.  */
 
+#ifdef __APPLE_CC__
+__private_extern__
+#endif
 int
 getloadavg (loadavg, nelem)
      double loadavg[];
@@ -626,14 +631,10 @@
 
 # endif /* __NetBSD__ */
 
-# if !defined (LDAV_DONE) && defined (NeXT)
+# if !defined (LDAV_DONE) && (defined(NeXT) || defined(RHAPSODY) || defined(DARWIN))
 #  define LDAV_DONE
   /* The NeXT code was adapted from iscreen 3.2.  */
 
-  host_t host;
-  struct processor_set_basic_info info;
-  unsigned info_count;
-
   /* We only know how to get the 1-minute average for this system,
      so even if the caller asks for more than 1, we only return 1.  */
 
@@ -643,10 +644,19 @@
 	getloadavg_initialized = 1;
     }
 
+#ifndef DARWIN
+#define processor_set_load_info processor_set_basic_info
+#define PROCESSOR_SET_LOAD_INFO PROCESSOR_SET_BASIC_INFO
+#define PROCESSOR_SET_LOAD_INFO_COUNT PROCESSOR_SET_BASIC_INFO_COUNT
+#endif
+
   if (getloadavg_initialized)
     {
-      info_count = PROCESSOR_SET_BASIC_INFO_COUNT;
-      if (processor_set_info (default_set, PROCESSOR_SET_BASIC_INFO, &host,
+      struct processor_set_load_info info;
+      host_t host;
+      unsigned info_count = PROCESSOR_SET_LOAD_INFO_COUNT;
+
+      if (processor_set_info (default_set, PROCESSOR_SET_LOAD_INFO, &host,
 			      (processor_set_info_t) &info, &info_count)
 	  != KERN_SUCCESS)
 	getloadavg_initialized = 0;
diff -u -Naur emacs-21.2/src/lisp.h emacs-f/src/lisp.h
--- emacs-21.2/src/lisp.h	Fri Feb 22 05:51:46 2002
+++ emacs-f/src/lisp.h	Thu Oct 10 11:01:23 2002
@@ -2770,7 +2770,7 @@
 extern void close_process_descs P_ ((void));
 extern void status_notify P_ ((void));
 extern int read_process_output P_ ((Lisp_Object, int));
-extern void init_process P_ ((void));
+extern void init_emacs_process P_ ((void));
 extern void syms_of_process P_ ((void));
 
 /* defined in callproc.c */
diff -u -Naur emacs-21.2/src/m/powermacintosh.h emacs-f/src/m/powermacintosh.h
--- emacs-21.2/src/m/powermacintosh.h	Wed Dec 31 19:00:00 1969
+++ emacs-f/src/m/powermacintosh.h	Thu Oct 10 11:01:23 2002
@@ -0,0 +1,45 @@
+/* Apple Power Macintosh machine/system dependent defines
+   Copyright (C) 1997 Free Software Foundation, Inc.
+
+This file is part of GNU Emacs.
+
+GNU Emacs is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Emacs is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Emacs; see the file COPYING.  If not, write to
+the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+
+/* The following line tells the configuration script what sort of 
+   operating system this machine is likely to run.
+   USUAL-OPSYS="darwin"  */
+
+/* Define WORDS_BIG_ENDIAN iff lowest-numbered byte in a word
+   is the most significant byte.  */
+
+#define WORDS_BIG_ENDIAN
+
+/* Define NO_ARG_ARRAY if you cannot take the address of the first of a
+ * group of arguments and treat it as an array of the arguments.  */
+
+#define NO_ARG_ARRAY
+
+/* Use type int rather than a union, to represent Lisp_Object */
+/* This is desirable for most machines.	 */
+
+#define NO_UNION_TYPE
+
+/* Define addresses, macros, change some setup for dump */
+
+#define NO_REMAP
+
+#define DATA_SEG_BITS 0
diff -u -Naur emacs-21.2/src/process.c emacs-f/src/process.c
--- emacs-21.2/src/process.c	Mon Jan  7 16:21:08 2002
+++ emacs-f/src/process.c	Thu Oct 10 11:01:23 2002
@@ -1482,7 +1482,11 @@
     current_dir = ENCODE_FILE (current_dir);
 
 #ifndef WINDOWSNT
+#ifndef PUMA_VFORK_ISSUES_CLEARED_UP
+    pid = fork ();
+#else
     pid = vfork ();
+#endif
     if (pid == 0)
 #endif /* not WINDOWSNT */
       {
@@ -4604,7 +4608,7 @@
 }
 
 void
-init_process ()
+init_emacs_process ()
 {
   register int i;
 
@@ -5003,7 +5007,7 @@
 }
 
 void
-init_process ()
+init_emacs_process ()
 {
 }
 
diff -u -Naur emacs-21.2/src/puresize.h emacs-f/src/puresize.h
--- emacs-21.2/src/puresize.h	Fri Feb 22 06:20:08 2002
+++ emacs-f/src/puresize.h	Thu Oct 10 11:01:23 2002
@@ -38,7 +38,7 @@
 #endif
 
 #ifndef SITELOAD_PURESIZE_EXTRA
-#define SITELOAD_PURESIZE_EXTRA 0
+#define SITELOAD_PURESIZE_EXTRA 100000
 #endif
 
 #ifndef BASE_PURESIZE
diff -u -Naur emacs-21.2/src/regex.c emacs-f/src/regex.c
--- emacs-21.2/src/regex.c	Fri Nov  2 11:10:25 2001
+++ emacs-f/src/regex.c	Thu Oct 10 11:01:23 2002
@@ -5831,6 +5831,9 @@
    It returns 0 if it succeeds, nonzero if it doesn't.  (See regex.h for
    the return codes and their meanings.)  */
 
+#ifdef __APPLE_CC__
+__private_extern__
+#endif
 int
 regcomp (preg, pattern, cflags)
     regex_t *__restrict preg;
@@ -5916,6 +5919,9 @@
 
    We return 0 if we find a match and REG_NOMATCH if not.  */
 
+#ifdef __APPLE_CC__
+__private_extern__
+#endif
 int
 regexec (preg, string, nmatch, pmatch, eflags)
     const regex_t *__restrict preg;
@@ -6030,6 +6036,9 @@
 
 /* Free dynamically allocated space used by PREG.  */
 
+#ifdef __APPLE_CC__
+__private_extern__
+#endif
 void
 regfree (preg)
     regex_t *preg;
diff -u -Naur emacs-21.2/src/s/darwin.h emacs-f/src/s/darwin.h
--- emacs-21.2/src/s/darwin.h	Wed Dec 31 19:00:00 1969
+++ emacs-f/src/s/darwin.h	Thu Oct 10 11:01:23 2002
@@ -0,0 +1,104 @@
+/* Configuration file for Darwin OS.
+   Copyright (C) 1997 Free Software Foundation, Inc.
+
+This file is part of GNU Emacs.
+
+GNU Emacs is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Emacs is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Emacs; see the file COPYING.  If not, write to
+the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+/* We give these symbols the numeric values found in <sys/param.h> to
+   avoid warnings about redefined macros.  */
+#define BSD 199506
+#define BSD4_3 1
+#define BSD4_4 1
+
+#include "bsd4-3.h"
+
+/* SYSTEM_TYPE should indicate the kind of system you are using.
+   It sets the Lisp variable system-type.  We'll need to undo the bsd one. */
+
+#undef SYSTEM_TYPE
+#define SYSTEM_TYPE "darwin"
+
+#ifndef DARWIN
+#define DARWIN
+#endif
+
+#undef KERNEL_FILE
+#define KERNEL_FILE "/mach_kernel"
+
+#define HAVE_ALLOCA
+
+#define HAVE_MACH_MACH_H
+
+#define SYSTEM_MALLOC
+
+#define WAIT_USE_INT
+
+#define SOCKLEN_TYPE int
+
+#define GETPGRP_NO_ARG
+
+#ifdef HAVE_LIBNCURSES
+#define TERMINFO
+#define LIBS_TERMCAP -lncurses
+#else
+#define TERMCAP_FILE "/usr/share/misc/termcap" 
+#endif
+
+#define PENDING_OUTPUT_COUNT(FILE) ((FILE)->_p - (FILE)->_bf._base)
+
+#define A_OUT_H_FILE <sys/exec.h>
+
+/* Data type of load average, as read out of kmem.  */
+#define LOAD_AVE_TYPE long
+
+#define ABORT_RETURN_TYPE __private_extern__ void
+
+/* Convert that into an integer that is 100 for a load average of 1.0  */
+#define LOAD_AVE_CVT(x) (int) (((double)(x)) * 100.0 / FSCALE)
+
+#define UNEXEC unexdyld.o
+
+/* Definitions for how to compile & link.  */
+
+/* Link this program just by running cc.  */
+#define ORDINARY_LINK
+
+/* #define C_SWITCH_SYSTEM */
+
+/* We don't have a g library, so override the -lg LIBS_DEBUG switch */
+#define LIBS_DEBUG
+
+/* Adding -lm confuses the dynamic linker, so omit it. */
+#define LIB_MATH
+
+/* Definitions for how to dump.  */
+
+#define START_FILES pre-crt0.o
+
+/* start_of_text isn't actually used, so make it compile without error.  */
+#define TEXT_START (0)
+
+/* This seems to be right for end_of_text, but it may not be used anyway.  */
+#define TEXT_END get_etext()
+
+/* This seems to be right for end_of_data, but it may not be used anyway.  */
+#define DATA_END get_edata()
+
+/* Don't close pty in process.c to make it a controlling terminal.  It is
+ * already the controlling terminal of the subprocess, because we did ioctl
+ * TIOCSCTTY.  */
+#define DONT_REOPEN_PTY
diff -u -Naur emacs-21.2/src/s/rhapsody.h emacs-f/src/s/rhapsody.h
--- emacs-21.2/src/s/rhapsody.h	Wed Dec 31 19:00:00 1969
+++ emacs-f/src/s/rhapsody.h	Thu Oct 10 11:01:23 2002
@@ -0,0 +1,89 @@
+/* Configuration file for Mac OS X Server.
+   Copyright (C) 1997 Free Software Foundation, Inc.
+
+This file is part of GNU Emacs.
+
+GNU Emacs is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Emacs is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Emacs; see the file COPYING.  If not, write to
+the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+/* We give these symbols the numeric values found in <sys/param.h> to
+   avoid warnings about redefined macros.  */
+#define BSD 199506
+#define BSD4_3 1
+#define BSD4_4 1
+
+#include "bsd4-3.h"
+
+/* SYSTEM_TYPE should indicate the kind of system you are using.
+   It sets the Lisp variable system-type.  We'll need to undo the bsd one. */
+
+#undef SYSTEM_TYPE
+#define SYSTEM_TYPE "apple-rhapsody"
+
+#ifndef RHAPSODY
+#define RHAPSODY
+#endif
+
+#define HAVE_ALLOCA
+
+#define HAVE_MACH_MACH_H
+
+#define SYSTEM_MALLOC
+
+#define WAIT_USE_INT
+
+#define SOCKLEN_TYPE int
+
+#define GETPGRP_NO_ARG
+
+#define TERMCAP_FILE "/usr/share/misc/termcap"
+
+#define PENDING_OUTPUT_COUNT(FILE) ((FILE)->_p - (FILE)->_bf._base)
+
+#define A_OUT_H_FILE <sys/exec.h>
+
+/* Data type of load average, as read out of kmem.  */
+#define LOAD_AVE_TYPE long
+
+/* Convert that into an integer that is 100 for a load average of 1.0  */
+#define LOAD_AVE_CVT(x) (int) (((double)(x)) * 100.0 / FSCALE)
+
+#define UNEXEC unexdyld.o
+
+/* Definitions for how to compile & link.  */
+
+/* Link this program just by running cc.  */
+#define ORDINARY_LINK
+
+/* #define C_SWITCH_SYSTEM */
+
+/* We don't have a g library, so override the -lg LIBS_DEBUG switch */
+#define LIBS_DEBUG
+
+/* Adding -lm confuses the dynamic linker, so omit it. */
+#define LIB_MATH
+
+/* Definitions for how to dump.  */
+
+#define START_FILES pre-crt0.o
+
+/* start_of_text isn't actually used, so make it compile without error.  */
+#define TEXT_START (0)
+
+/* This seems to be right for end_of_text, but it may not be used anyway.  */
+#define TEXT_END get_etext()
+
+/* This seems to be right for end_of_data, but it may not be used anyway.  */
+#define DATA_END get_edata()
diff -u -Naur emacs-21.2/src/sysdep.c emacs-f/src/sysdep.c
--- emacs-21.2/src/sysdep.c	Mon Nov 19 09:48:11 2001
+++ emacs-f/src/sysdep.c	Thu Oct 10 11:01:23 2002
@@ -813,7 +813,11 @@
   synch_process_alive = 1;
 #endif /* __DJGPP__ > 1 */
 #else  
+#ifndef PUMA_VFORK_ISSUES_CLEARED_UP
+  pid = fork ();
+#else
   pid = vfork ();
+#endif
   if (pid == -1)
     error ("Can't spawn subshell");
 #endif
diff -u -Naur emacs-21.2/src/termcap.c emacs-f/src/termcap.c
--- emacs-21.2/src/termcap.c	Mon May 28 07:58:27 2001
+++ emacs-f/src/termcap.c	Thu Oct 10 11:01:23 2002
@@ -144,6 +144,9 @@
   return NULL;
 }
 
+#ifdef __APPLE_CC__
+__private_extern__
+#endif
 int
 tgetnum (cap)
      char *cap;
@@ -154,6 +157,9 @@
   return atoi (ptr);
 }
 
+#ifdef __APPLE_CC__
+__private_extern__
+#endif
 int
 tgetflag (cap)
      char *cap;
@@ -167,6 +173,9 @@
    to store the string.  That pointer is advanced over the space used.
    If AREA is null, space is allocated with `malloc'.  */
 
+#ifdef __APPLE_CC__
+__private_extern__
+#endif
 char *
 tgetstr (cap, area)
      char *cap;
@@ -291,6 +300,9 @@
 
 /* If OSPEED is 0, we use this as the actual baud rate.  */
 int tputs_baud_rate;
+#ifdef __APPLE_CC__
+__private_extern__
+#endif
 char PC;
 
 #if 0 /* Doesn't seem to be used anymore.  */
@@ -311,6 +323,9 @@
 
 #endif /* 0  */
 
+#ifdef __APPLE_CC__
+__private_extern__
+#endif
 void
 tputs (str, nlines, outfun)
      register char *str;
@@ -436,6 +451,9 @@
    0 if the data base is accessible but the type NAME is not defined
    in it, and some other value otherwise.  */
 
+#ifdef __APPLE_CC__
+__private_extern__
+#endif
 int
 tgetent (bp, name)
      char *bp, *name;
diff -u -Naur emacs-21.2/src/tparam.c emacs-f/src/tparam.c
--- emacs-21.2/src/tparam.c	Fri Dec  8 04:58:48 2000
+++ emacs-f/src/tparam.c	Thu Oct 10 11:01:23 2002
@@ -110,6 +110,9 @@
 
 static char tgoto_buf[50];
 
+#ifdef __APPLE_CC__
+__private_extern__
+#endif
 char *
 tgoto (cm, hpos, vpos)
      char *cm;
